// TGS2450 sensor unit drive and measure
#include <time.h>
#include <wiringPi.h>
#include <stdio.h>
main(){
  const int LED_RED_OUT = 5;
  const int SENSOR_OUT = 24; 
  const int HEATER_OUT = 25;
  const int SENSOR_IN  = 27;
  if(wiringPiSetupGpio()<0){return -1; }
  pinMode(LED_RED_OUT,OUTPUT);
  pinMode(SENSOR_OUT ,OUTPUT);
  pinMode(HEATER_OUT ,OUTPUT);
  pinMode(SENSOR_IN  ,INPUT);
  pullUpDnControl(SENSOR_IN,PUD_OFF);
  while(1){
    int adcnt; //A/D count
    for(int i=0;i<100;i++){
      digitalWrite(HEATER_OUT ,0);
      delay(10);  //10msec
      digitalWrite(HEATER_OUT ,1);
      delay(200); //200msec
      digitalWrite(LED_RED_OUT,1);
      digitalWrite(SENSOR_OUT ,0);
      delay(2);    // 2 msec
      for(adcnt=1 ;adcnt<400; adcnt++){
        delayMicroseconds(10);
        if(digitalRead(SENSOR_IN)) break;
      } //adcnt is A/D out
      digitalWrite(SENSOR_OUT ,1);
      digitalWrite(LED_RED_OUT,0);
    }
    time_t now;
    time(&now);
    struct tm *lt = localtime(&now);
    printf("%02d/%02d/%02d:%02d:%02d %d\n", lt->tm_mon+1, lt->tm_mday, 
      lt->tm_hour, lt->tm_min,lt->tm_sec, adcnt);
    fflush(stdout);
  }
}
